//Edited 26-10-2015
//sin(ph/2) ph/2 dph case
//Squid and majorana fermions (based on Veldhorst Hilgenkamp Phys Rev B 86, 024509 (2012))
//We also take in to acoount external radiation
//With beta_L
#include<iostream>
#include<math.h>
#include<iomanip>
#include<stdio.h>
#include<stdlib.h>

using namespace std;
int main()
	{
	char str[100];

	int
		t,	//index of time
			//индекс по времени
		d, //index of magnetic flux
		k, // index of recording zero voltage current
		ti,	//number of time cycles from which of we begin integration
			//номер цикла по времени с которого начнается интегрирование
		a=1,//parameter for direction of current
			//параметр для определения направлении тока
		tN,	//total number of time cycles
			//количество точек (циклов) по времени
		pheN,    //total number of phe cycles
		maxcurrent=0,
		cvc=1,//if you want save cvc put "cvc=1"
		m,
		min,
		max;
	//######################################################################################
	double
		pi=3.14159265358979323846,

		Ti=50,	//Initial value of time averaging
				//Начальная значения времени усреднения
		Tf=800,//Time domain for one step of current
				//Временной домен для одного шага тока
		TP=0.05,//Step of time
				//Шаг по времени
		JP=0.001,	//Step of current
					//Шаг по току
		I0=0,	//Initial value of bias current
				//Начальное значения тока
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		phemax=2,
		phemin=-2,
		deltaphe=0.01,

		Omega=0,//Частота внешнего излучения
		Amp=0,	//Амплитуда внешнего излучения

		alpha1=0,
		alpha2=0,
		gamma_l=1,
		gamma_j=2.,

		n=0,
		beta_c=10,	//Dissipation parameter
					//Параметр диссипации
		beta_L=1.,	//Dissipation parameter
					//Параметр диссипации
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		phe,

		stephight,
		ICounter,

		intV1,	intV2,	//Variable for voltage integration
						//Переменный для интегрирования напряжении

		//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		//Runge-Kutta coefficients
		//Коэффициенты Рунге-Кутта
		P1_1,P1_2,P1_3,P1_4,
		V1_1,V1_2,V1_3,V1_4,

		P2_1,P2_2,P2_3,P2_4,
		V2_1,V2_2,V2_3,V2_4,
		//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		V1, V2,	//Variable for Voltage at fixed time
			//Переменный для напряжение в фиксированном времени

		V1av, V2av,
		ph1,	//Variable for phase differences at fixed time
			//Переменный для разности фаз в фиксированном времени
		ph2,	//Variable for phase differences at fixed time
			//Переменный для разности фаз в фиксированном времени
		I;	//Bias current
			//Входной ток
		int s=9/JP;

		double I_critical[s];

//#######################################################################################
	//Creation result's files
	//Создания файлов для результатов
	FILE *f,*fphe;
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	//file for field dependence of Ic
	fphe = fopen("I_critical_phe.dat", "w");
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	pheN=((phemax-phemin)/deltaphe)+1;//Вичисления количество точек по амплитуде

	//*****************************************************************
	tN=(Tf/TP);
	ti=tN*Ti/Tf;
//#######################################################################
	phe=phemin;
	d=0;
	do{	//Here we define initial condition for phase
		//initial condition
		//начальных условий
		intV1=0;
		intV2=0;
		V1=0;
		V2=0;
		ICounter=0;
		I=I0;

		k=0;
		ph1=gamma_j*pi*(n-phe/gamma_l);
		ph2=-ph1;
	  	maxcurrent=0;
		//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		if(cvc==1){
			//file for total CVC
			//файл для полного ВАХ
			sprintf(str,"Voltage_Ph_ext_%.4f.dat",phe);
			f=fopen(str,"w");
		}

		do{	// Here the cycle of current begins
			//Здесь начинается цикл по току
			t=0;
			do{	//Here the cycle of time begins
				//Здесь начинается цикл по времени
		//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
			//Starting of Runge-Kutta method
			//Начало метода Рунге-Кутта
			//$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
			//The first coefficients of Runge-Kutta method
			//Первые коэффициенты метода Рунге-Кутта
				V1_1=(TP/beta_c)*(
					(1./2)*(I+Amp*sin(Omega*(t*TP+ICounter*tN*TP)))
					-V1-(alpha1*sin(ph1)+(1-alpha1)*sin(ph1/2))
					+(gamma_l/(2*beta_L))*(2*pi*n-(ph1-ph2)/gamma_j-(2*pi*phe/gamma_l))
				);
				P1_1=TP*V1;

				V2_1=(TP/beta_c)*(
					(1./2)*(I+Amp*sin(Omega*(t*TP+ICounter*tN*TP)))
					-V2-(alpha2*sin(ph2)+(1-alpha2)*sin(ph2/2))
					-(gamma_l/(2*beta_L))*(2*pi*n-(ph1-ph2)/gamma_j-(2*pi*phe/gamma_l))
				);
				P2_1=TP*V2;
			//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
			//The second coefficients of Runge-Kutta method
			//Вторые коэффициенты метода Рунге-Кутта
				V1_2=(TP/beta_c)*(
					(1./2)*(I+Amp*sin(Omega*(t*TP+TP/2+ICounter*tN*TP)))
					-(V1+V1_1/2)-(alpha1*sin(ph1+P1_1/2)+(1-alpha1)*sin((ph1+P1_1/2)/2))
					+(gamma_l/(2*beta_L))*(2*pi*n-((ph1+P1_1/2)-(ph2+P2_1/2))/gamma_j-(2*pi*phe/gamma_l))
				);
				P1_2=TP*(V1+V1_1/2);

				V2_2=(TP/beta_c)*(
					(1./2)*(I+Amp*sin(Omega*(t*TP+TP/2+ICounter*tN*TP)))
					-(V2+V2_1/2)-(alpha2*sin(ph2+P2_1/2)+(1-alpha2)*sin((ph2+P2_1/2)/2))
					-(gamma_l/(2*beta_L))*(2*pi*n-((ph1+P1_1/2)-(ph2+P2_1/2))/gamma_j-(2*pi*phe/gamma_l))
				);
				P2_2=TP*(V2+V2_1/2);
			//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
			//The third coefficients of Runge-Kutta method
			//Третые коэффициенты метода Рунге-Кутта
				V1_3=(TP/beta_c)*(
					(1./2)*(I+Amp*sin(Omega*(t*TP+TP/2+ICounter*tN*TP)))
					-(V1+V1_2/2)-(alpha1*sin(ph1+P1_2/2)+(1-alpha1)*sin((ph1+P1_2/2)/2))
					+(gamma_l/(2*beta_L))*(2*pi*n-((ph1+P1_2/2)-(ph2+P2_2/2))/gamma_j-(2*pi*phe/gamma_l))
				);
				P1_3=TP*(V1+V1_2/2);

				V2_3=(TP/beta_c)*(
					(1./2)*(I+Amp*sin(Omega*(t*TP+TP/2+ICounter*tN*TP)))
					-(V2+V2_2/2)-(alpha2*sin(ph2+P2_2/2)+(1-alpha2)*sin((ph2+P2_2/2)/2))
					-(gamma_l/(2*beta_L))*(2*pi*n-((ph1+P1_2/2)-(ph2+P2_2/2))/gamma_j-(2*pi*phe/gamma_l))
				);
				P2_3=TP*(V2+V2_2/2);
			//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
			//The fourth coefficients of Runge-Kutta method
			//Четвертые коэффициенты метода Рунге-Кутта
				V1_4=(TP/beta_c)*(
					(1./2)*(I+Amp*sin(Omega*(t*TP+TP+ICounter*tN*TP)))
					-(V1+V1_3)-(alpha1*sin(ph1+P1_3)+(1-alpha1)*sin((ph1+P1_3)/2))
					+(gamma_l/(2*beta_L))*(2*pi*n-((ph1+P1_3)-(ph2+P2_3))/gamma_j-(2*pi*phe/gamma_l))
				);
				P1_4=TP*(V1+V1_3);

				V2_4=(TP/beta_c)*(
					(1./2)*(I+Amp*sin(Omega*(t*TP+TP+ICounter*tN*TP)))
					-(V2+V2_3)-(alpha2*sin(ph2+P2_3)+(1-alpha2)*sin((ph2+P2_3)/2))
					-(gamma_l/(2*beta_L))*(2*pi*n-((ph1+P1_3)-(ph2+P2_3))/gamma_j-(2*pi*phe/gamma_l))
				);
				P2_4=TP*(V2+V2_3);
				//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
				ph1=ph1+(P1_1+2*P1_2+2*P1_3+P1_4)/6;
				V1=V1+(V1_1+2*V1_2+2*V1_3+V1_4)/6;

				ph2=ph2+(P2_1+2*P2_2+2*P2_3+P2_4)/6;
				V2=V2+(V2_1+2*V2_2+2*V2_3+V2_4)/6;

				if (t>ti){
					intV1=V1*TP+intV1;
					intV2=V2*TP+intV2;
				}
				//if((at==1)&&(I>(Itime1-JP1/2))&&(ph_begin==0)){ph_time=ph; ph_begin=1;}
				//if((at==-1)&&(I<(Itime2+JP1/2))&&(ph_begin==0)){ph_time=ph; ph_begin=1;}
	//Ending of Runge-Kutta method
	//Конец метода Рунге-Кутта
	//$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
	//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
			//Here the cycle of time finishs
			//Здесь цикл по времени закончивается
			}while(++t<tN+1);
			//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
			//Voltage averaging
			//Усреднение напряжения
			V1av=intV1/(Tf-Ti);
			intV1=0;

			V2av=intV2/(Tf-Ti);
			intV2=0;
			//------------------------------
			if((V2av<0.005)&&(V2av>-0.005)){
					//Если напряжение соответсвует ступеньке записывается значение тока
					I_critical[k]=I;
					k=++k;//Счетчик который регистрирует количество значений тока в ступеньке
				};
			//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
			//showing results on the screen
			//вывод результатов на экран
			cout<<"\n\nI:"<<I<<"\tV:"<<V1av<<"\tV:"<<V2av;
			//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
			//Here will be recorded bias Current and total voltage
			//Здесь записывается входной ток и суммарное напряжение
			if(cvc==1){
				fprintf(f,"%f\t%e\t%e\n",I,V1av,V2av);
			}
			//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
			ICounter=ICounter+1;

			//Here bias current will be changed
			//Здесь изменяется направление тока

			if((V2av>0.2)&&(a==1)){maxcurrent=1;}

			I=I+a*JP;
			//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
			if(maxcurrent==1)
				{	if(cvc==1){
						fclose (f);
					}
					break;
				};
			//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		//Here cycle of current finishs
		//Здесь закончивается цикл по току
		}while(I<=100);
		//**********************
		//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		min=0; max=0;
		m=0;
		do{	if (I_critical[m] < I_critical[min]){ min = m;};
			if (I_critical[m] > I_critical[max]){ max = m;};
		}while(++m<k);
		//Здесь вычисляем ширину ступеньки
		stephight=(I_critical[max]-I_critical[min]);
		//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		cout<<"\n\n Phe:"<<phe<<"\t I_critical:"<<stephight;
		//Здесь записываем полученных данных в файл
		fprintf(fphe,"%f\t%e\n",phe,stephight);
		// Here all files will be closed
		//Здесь все файлы закрываются
		phe=phe+deltaphe;
	}while(++d<pheN);
	fclose(fphe);
return(0);
}
