//Edited 12-03-2015
//SQUID Based on the stacks of JJ
//Программа для исследования двух параллельно соединенных стеков ДП учетом внешнего магнитног поля
//Вычисляются ВАХ, зависимость отдельных токов от базового тока и временные зависимости заряда и напряжения
#include<iostream>
#include<math.h>
#include<iomanip>
#include<stdio.h>
#include<stdlib.h>
#include <fstream>

using namespace std;

int main()
{	const int N1=1;	//Количество ДП в первом стеке
	const int N2=1;	//количество ДП во втором ДП

	char c='p'; //for periodic BC put 'p' and for nonperiodic BC put 'n'
				//В случае периодических граничных условий вставте 'p' а не периодических 'n'

	int a=1,//parameter for direction of current
			//параметр для определения направлении тока
		i,	//index of junctions
			//индекс по контактам
		pt,
		M1,M2,//Количество циклов по ДП: при периодическом ГУ M=N+1; при не периодическом ГУ M=N
		t,	//index of time
			//индекс по времени
		tN,	//Количество циклов по времени
		ti,	//number of time cycles from which of we begin integration
			//номер цикла по времени с которого начнается интегрирование
				//Параметр для проверки записи временных зависимостей
		at=1,	//in up or down for time dependence put 1 or -1
				//Направление тока при котором записывается временная зависимость
		ICounter,
		time_dep=1;
	//----------------------------------------------------------------------------------

	double
		pi=3.1415926535897932384626433,

		//Parameters of external radiation
		Omega=0.5,//Частота внешнего излучения
		Amp=0,//Амплитуда внешнего излучения
		Tf_rad0=256,
		Tf_rad1=256,
		Ti_rad=64,
		TP_rad=1.0/64;
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	double

		Ti=50,	//Initial value of time averaging
				//Начальная значения времени усреднения
		Tf0=5000,//Time domain for one step of current
				//Временной домен для одного шага тока
		Tf1=5000,//Time domain for one step of current
				//Временной домен для одного шага тока
		JP0=0.0005,	//Step of current out of current interval [Imore1,Imore2]
					//Шаг по току вне интервала [Imore1,Imore2]
		JP1=0.0005,	//Step of current inside current interval [Imore1,Imore2]
					//Шаг по току в интервале [Imore1,Imore2]
		TP=0.05,//Step of time
				//Шаг по времени
		I0=0.1,//Initial value of bias current
				//Начальное значения тока
		Imax=3,	//Maximal value of bias current
				//Максимальное значения тока
		Imore1=0.2,//Начало интервала, в котором меняется шаг по току на JP1
		Imore2=3,//Конец интервала, в котором меняется шаг по току на JP1
		noismax=0,//Noise amplitude of bias current
					//Амплитуда шума тока
		beta_c=10,//Dissipation parameter
				//Параметр диссипации
		beta_L=1,
		alpha=0.1,//Coupling parameter between of JJs of stack
				//Параметр связи между ДП стека
		gamma=0,//Parameter for boundary condition of first stack
				//Параметр для граничных услвий для первого стека

		nu_j=2,
		nu_l=1,
		epsilon=0,
		n=0,
		phe=0.5,

		Itime1=2.04,//Начало интервала по току, в котором записывается временные зависимости
		Itime2=2.04,//Конец интервала по току, в котором записывается временные зависимости

	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	//Переменные для матричных операций
		time, Tf,T,
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		P1[N2+2],P2[N2+2],P3[N2+2],P4[N2+2],
		V1[N2+2],V2[N2+2],V3[N2+2],V4[N2+2],
		ph[N2+2],
		V[N2+2], intV[N2+2], Vav[N2+2],	v,
		dph[N2+2],intdph[N2+2],dphav[N2+2],
		Ps1[N1+2],	Ps2[N1+2],	Ps3[N1+2],	Ps4[N1+2],
		U1[N1+2],	U2[N1+2],	U3[N1+2],	U4[N1+2],
		ps[N1+2],
		U[N1+2],	intU[N1+2],	Uav[N1+2],	u,
		dps[N1+2],	intdps[N1+2],dpsav[N1+2],

		Ch1[N1+2],
		Ch2[N2+2],

		Is1[N1+2],		intIs1[N1+2],	Is1av[N1+2],
		Idisp1[N1+2],	intIdisp1[N1+2],Idisp1av[N1+2],
		Iqp1[N1+2],		intIqp1[N1+2],	Iqp1av[N1+2],
		Idif1[N1+2],	intIdif1[N1+2],	Idif1av[N1+2],

		Is2[N2+2],		intIs2[N2+2],	Is2av[N2+2],
		Idisp2[N2+2],	intIdisp2[N2+2],Idisp2av[N2+2],
		Iqp2[N2+2],		intIqp2[N2+2],	Iqp2av[N2+2],
		Idif2[N2+2],	intIdif2[N2+2],	Idif2av[N2+2],

		Isum[N1+N2+2],
		Isum1[N1+2],	intIsum1[N1+2],	Isum1av[N1+2],
		Isum2[N2+2],	intIsum2[N2+2],	Isum2av[N2+2],

		U0[N1+2],	V0[N2+2],
		Irand1[N1+2],Irand2[N2+2],
		sumps,	sumph,
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		I,JP;
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	I=I0; JP=JP0;

	if((Omega>0.001)&&(Amp>0.001)){
		T=(2*pi)/Omega;

		Tf1=Tf_rad1*T;
		Tf0=Tf_rad0*T;
		Ti=Ti_rad*T;
		TP=TP_rad*T;
	}

	Tf=Tf0;
	tN=Tf/TP; ti=tN*Ti/Tf;
	ICounter=0;
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	//Начало создание файлов&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
	FILE
	*cvctotal,		*cvctotalup,		*cvctotaldown,
	*cvctotalj1,	*cvctotalj1up,		*cvctotalj1down,
	*cvctotalj2,	*cvctotalj2up,		*cvctotalj2down,

	*cvcstack1,		*cvcstack1up,	*cvcstack1down,
	*cvcstack2,		*cvcstack2up,	*cvcstack2down,

	*fdpstotalup,	*fdpstotaldown,
	*fdphtotalup,	*fdphtotaldown,

	*fdpsstackup,		*fdphstackup,
	*fdpsstackdown,	*fdphstackdown,

	*fIs1up,	*fIs1down,		*fIs1stack1up,		*fIs1stack1down,
	*fIqp1up,	*fIqp1down,		*fIqp1stack1up,		*fIqp1stack1down,
	*fIdisp1up, *fIdisp1down,	*fIdisp1stack1up,	*fIdisp1stack1down,
	*fIdif1up,	*fIdif1down,	*fIdif1stack1up,	*fIdif1stack1down,

	*fIs2up,	*fIs2down,		*fIs2stack2up,		*fIs2stack2down,
	*fIqp2up,	*fIqp2down,		*fIqp2stack2up,		*fIqp2stack2down,
	*fIdisp2up,	*fIdisp2down,	*fIdisp2stack2up,	*fIdisp2stack2down,
	*fIdif2up,	*fIdif2down,	*fIdif2stack2up,	*fIdif2stack2down,

	*fchtime1,*fchtime2,*fvtime1, *fvtime2,
	*totalI,

	*fIs1time,		*fIs2time,
	*fIqp1time,		*fIqp2time,
	*fIdisp1time,	*fIdisp2time,
	*fIdif1time,	*fIdif2time;
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	//Создание файлов для записи полной ВАХ системы
	cvctotal=fopen("cvc_total.dat","w");
	cvctotalup=fopen("cvc_total_up.dat","w");
	cvctotaldown=fopen("cvc_total_down.dat","w");
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	//Создание файлов для записи полной ВАХ
	//и ВАХ на каждом ДП первого стека от внешнего тока
	cvctotalj1=fopen("cvc_total_j1.dat","w");
	cvctotalj1up=fopen("cvc_total_j1_up.dat","w");
	cvctotalj1down=fopen("cvc_total_j1_down.dat","w");
	//Создание файлов для записи полной ВАХ
	//и ВАХ на каждом ДП второго стека от внешнего тока
	cvctotalj2=fopen("cvc_total_j2.dat","w");
	cvctotalj2up=fopen("cvc_total_j2_up.dat","w");
	cvctotalj2down=fopen("cvc_total_j2_down.dat","w");
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	//Создание файлов для ВАХ первого стека U(I1)
	cvcstack1=fopen("cvc_stack1.dat","w");
	cvcstack1up=fopen("cvc_stack1_up.dat","w");
	cvcstack1down=fopen("cvc_stack1_down.dat","w");
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	//Создание файлов для ВАХ второго стека V(I2)
	cvcstack2=fopen("cvc_stack2.dat","w");
	cvcstack2up=fopen("cvc_stack2_up.dat","w");
	cvcstack2down=fopen("cvc_stack2_down.dat","w");
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	//Создание файлов для записи производной разности фаз по времени
	fdpstotalup=fopen("dps_total_up.dat","w");
	fdpsstackup=fopen("dps_stack_up.dat","w");
	fdphtotalup=fopen("dph_total_up.dat","w");
	fdphstackup=fopen("dph_stack_up.dat","w");

	fdpstotaldown=fopen("dps_total_down.dat","w");
	fdpsstackdown=fopen("dps_stack_down.dat","w");
	fdphtotaldown=fopen("dph_total_down.dat","w");
	fdphstackdown=fopen("dph_stack_down.dat","w");
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	//Создание файлов для сверхпроводящего тока в первом стеке
	fIs1up=fopen("Is1_I_up.dat","w");
	fIs1stack1up=fopen("Is1_stack1_up.dat","w");

	fIs1down=fopen("Is1_I_down.dat","w");
	fIs1stack1down=fopen("Is1_stack1_down.dat","w");
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	//Создание файлов для квазичастичного тока в первом стеке
	fIqp1up=fopen("Iqp1_I_up.dat","w");
	fIqp1stack1up=fopen("Iqp1_stack1_up.dat","w");

	fIqp1down=fopen("Iqp1_I_down.dat","w");
	fIqp1stack1down=fopen("Iqp1_stack1_down.dat","w");
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	//Создание файлов для тока смещения в первом стеке
	fIdisp1up=fopen("Idisp1_I_up.dat","w");
	fIdisp1stack1up=fopen("Idisp1_stack1_up.dat","w");

	fIdisp1down=fopen("Idisp1_I_down.dat","w");
	fIdisp1stack1down=fopen("Idisp1_stack1_down.dat","w");
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	//Создание файлов для диффузионного тока в первом стеке
	fIdif1up=fopen("Idif1_I_up.dat","w");
	fIdif1stack1up=fopen("Idif1_stack1_up.dat","w");

	fIdif1down=fopen("Idif1_I_down.dat","w");
	fIdif1stack1down=fopen("Idif1_stack1_down.dat","w");
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	//Создание файлов для сверхпроводящего тока во втором стеке
	fIs2up=fopen("Is2_I_up.dat","w");
	fIs2stack2up=fopen("Is2_stack2_up.dat","w");

	fIs2down=fopen("Is2_I_down.dat","w");
	fIs2stack2down=fopen("Is2_stack2_down.dat","w");
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	//Создание файлов для квазичастичного тока во втором стеке
	fIqp2up=fopen("Iqp2_I_up.dat","w");
	fIqp2stack2up=fopen("Iqp2_stack2_up.dat","w");

	fIqp2down=fopen("Iqp2_I_down.dat","w");
	fIqp2stack2down=fopen("Iqp2_stack2_down.dat","w");
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	//Создание файлов для тока смещения во втором стеке
	fIdisp2up=fopen("Idisp2_I_up.dat","w");
	fIdisp2stack2up=fopen("Idisp2_stack2_up.dat","w");

	fIdisp2down=fopen("Idisp2_I_down.dat","w");
	fIdisp2stack2down=fopen("Idisp2_stack2_down.dat","w");
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	//Создание файлов для диффузионного тока во втором стеке
	fIdif2up=fopen("Idif2_I_up.dat","w");
	fIdif2stack2up=fopen("Idif2_stack2_up.dat","w");

	fIdif2down=fopen("Idif2_I_down.dat","w");
	fIdif2stack2down=fopen("Idif2_stack2_down.dat","w");
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	if(time_dep==1){
		//Создание файлов для записи временных зависимостей
		fchtime1=fopen("Charge_time1.dat","w");
		fchtime2=fopen("Charge_time2.dat","w");
		fvtime1=fopen("Voltage_time1.dat","w");
		fvtime2=fopen("Voltage_time2.dat","w");
		//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		//Создание файлов для записи временных зависимостей токов
		fIs1time =fopen("Is1_time.dat","w");
		fIqp1time=fopen("Iqp1_time.dat","w");
		fIdisp1time=fopen("Idisp1_time.dat","w");
		fIdif1time=fopen("Idif1_time.dat","w");

		fIs2time =fopen("Is2_time.dat","w");
		fIqp2time=fopen("Iqp2_time.dat","w");
		fIdisp2time=fopen("Idisp2_time.dat","w");
		fIdif2time=fopen("Idif2_time.dat","w");
	}
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	totalI=fopen("total_current.dat","w");
	//Конец создание файлов&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	// Нулеые начальные условия
	i=0;
	do{	ps[i]=0;
		U[i]=0;
		Uav[i]=0;
		intU[i]=0;
		intIs1[i]=0;
		intIdisp1[i]=0;
		intIqp1[i]=0;
		intIdif1[i]=0;
		intIsum1[i]=0;
		intdps[i]=0;
	}while(++i<=N1+1);

	i=0;
	do{	ph[i]=0;
		V[i]=0;
		Vav[i]=0;
		intV[i]=0;
		intIs2[i]=0;
		intIdisp2[i]=0;
		intIqp2[i]=0;
		intIdif2[i]=0;
		intIsum2[i]=0;
		intdph[i]=0;
	}while(++i<=N2+1);
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	// $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
	//Generation of noise
	//Генерация шума
	long int ranmax=0,ran=0;
	long long x1;
	i=1;
	do{	asm("rdtsc" : "=A"(x1));
		srand(x1);
		ran=rand();
		if(ranmax<ran)ranmax=ran;
	}while(++i<=100);

	cout<<"random max is :"<<ranmax<<endl;
	float irand;
	int randa[2000];

	i=1;
	do{	irand=rand();
		irand=2*(irand/ranmax-0.5);
		ran=100*irand;
		randa[ran+100]=randa[ran+100]+1;
	}while(++i<=1000000);
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	//Generation of noise $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
	//Начало генерации шума
/*	char *a12;
	unsigned  i1,i2=1;
	long int ranmax=0,ran=0;
	i=1;
	do{	initstate(i1,a12,i2);
		ran=random();
		if(ranmax<ran)ranmax=ran;
	}while(++i<=100000);
	cout<<"random max is :"<<ranmax<<endl;
	float rand;
	int randa[2000];
	i=1;
	do{	initstate(i1,a12,i2);
		rand=random();
		rand=2*(rand/ranmax-0.5);
		ran=100*rand;
		randa[ran+100]=randa[ran+100]+1;
	}while(++i<=1000000);
*/	//Конец генерации шума $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
	//Начало цикла по току%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	do{	t=0;
		do{	//Начало цикла по времени

			//Noise calculation
			//вычисления шума
			i=1;
			do{	irand=rand();
				irand=2*(irand/ranmax-0.5);
				Irand1[i]=noismax*irand;
				U0[i]=U[i];
			}while(++i<=N1);

			i=1;
			do{	irand=rand();
				irand=2*(irand/ranmax-0.5);
				Irand2[i]=noismax*irand;
				V0[i]=V[i];
			}while(++i<=N2);
			//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		//Starting of Runge-Kutta method
		//Начало метода Рунге-Кутта
			//$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
			//The first coefficients of Runge-Kutta method
			//Первые коэффициенты метода Рунге-Кутта

			if(N1==1){
				dps[N1]=U[N1];
				Ps1[N1]=TP*dps[N1];
			}else{
				if(c=='n'){
					i=1;
					dps[i]=(U[i])-alpha*(U[i+1]-(1+gamma)*U[i]);
					Ps1[i]=TP*dps[i];

					i=N1;
					dps[i]=(U[i])-alpha*(U[i-1]-(1+gamma)*U[i]);
					Ps1[i]=TP*dps[i];
					i=2; M1=N1;
				}

				if(c=='p'){i=1; U[0]=U[N1]; U[N1+1]=U[1];M1=N1+1;}
				do{	dps[i]=U[i]-alpha*(U[i+1]+U[i-1]-2*U[i]);
					Ps1[i]=TP*dps[i];
				}while(++i<M1);
			}


			if(N2==1){
				dph[N2]=V[N2];
				P1[N2]=TP*dph[N2];
			}else{
				if(c=='n'){
					i=1;
					dph[i]=(V[i])-alpha*(V[i+1]-(1+gamma)*V[i]);
					P1[i]=TP*dph[i];

					i=N2;
					dph[i]=(V[i])-alpha*(V[i-1]-(1+gamma)*V[i]);
					P1[i]=TP*dph[i];
					i=2; M2=N2;
				}

				if(c=='p'){i=1; V[0]=V[N2]; V[N2+1]=V[1]; M2=N2+1;}
				do{	dph[i]=V[i]-alpha*(V[i+1]+V[i-1]-2*V[i]);
					P1[i]=TP*dph[i];
				}while(++i<M2);
			}

			sumps=0; i=1;
			do{sumps=sumps+ps[i];
			}while(++i<=N1);

			sumph=0; i=1;
			do{sumph=sumph+ph[i];
			}while(++i<=N2);

			i=1;
			do{	U1[i]=(TP/beta_c)*(((I+Amp*sin(Omega*(t*TP+ICounter*tN*TP)))/2)+Irand1[i]-dps[i]-
				(epsilon*sin(ps[i])+(1-epsilon)*sin(ps[i]/2))
				+(1./(2*beta_L))*(2*pi*(n-(phe/nu_l))-((sumps-sumph)/nu_j)));
			}while(++i<=N1);

			i=1;
			do{	V1[i]=(TP/beta_c)*(((I+Amp*sin(Omega*(t*TP+ICounter*tN*TP)))/2)+Irand2[i]-dph[i]-
				(epsilon*sin(ph[i])+(1-epsilon)*sin(ph[i]/2))
				-(1./(2*beta_L))*(2*pi*(n-(phe/nu_l))-((sumps-sumph)/nu_j)));
			}while(++i<=N2);

			//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
			//The second coefficients of Runge-Kutta method
			//Вторые коэффициенты метода Рунге-Кутта
			if(N1==1){
				dps[N1]=U[N1]+(U1[N1]/2);
				Ps2[N1]=TP*dps[N1];
			}else{
				if(c=='n'){
					i=1;
					dps[i]=(U[i]+(U1[i]/2))-alpha*(U[i+1]+(U1[i+1]/2)-(1+gamma)*(U[i]+(U1[i]/2)));
					Ps2[i]=TP*dps[i];

					i=N1;
					dps[i]=(U[i]+(U1[i]/2))-alpha*(U[i-1]+(U1[i-1]/2)-(1+gamma)*(U[i]+(U1[i]/2)));
					Ps2[i]=TP*dps[i];
					i=2; M1=N1;
				}

				if(c=='p'){i=1; U[0]=U[N1]; U1[0]=U1[N1]; U[N1+1]=U[1]; U1[N1+1]=U1[1]; M1=N1+1;}
				do{	dps[i]=U[i]+(U1[i]/2)-alpha*(U[i+1]+(U1[i+1]/2)+(U[i-1]+(U1[i-1]/2))-2*(U[i]+(U1[i]/2)));
					Ps2[i]=TP*dps[i];
				}while(++i<M1);
			}

			if(N2==1){
				dph[N2]=V[N2]+(V1[N2]/2);
				P2[N2]=TP*dph[N2];
			}else{
				if(c=='n'){
					i=1;
					dph[i]=(V[i]+(V1[i]/2))-alpha*(V[i+1]+(V1[i+1]/2)-(1+gamma)*(V[i]+(V1[i]/2)));
					P2[i]=TP*dph[i];

					i=N2;
					dph[i]=(V[i]+(V1[i]/2))-alpha*(V[i-1]+(V1[i-1]/2)-(1+gamma)*(V[i]+(V1[i]/2)));
					P2[i]=TP*dph[i];
					i=2; M2=N2;
				}

				if(c=='p'){i=1; V[0]=V[N2]; V1[0]=V1[N2]; V[N2+1]=V[1]; V1[N2+1]=V1[1]; M2=N2+1;}
				do{	dph[i]=V[i]+(V1[i]/2)-alpha*(V[i+1]+(V1[i+1]/2)+V[i-1]+(V1[i-1]/2)-2*(V[i]+(V1[i]/2)));
					P2[i]=TP*dph[i];
				}while(++i<M2);
			}

			sumps=0; i=1;
			do{sumps=sumps+ps[i]+(Ps1[i]/2);
			}while(++i<=N1);

			sumph=0; i=1;
			do{sumph=sumph+ph[i]+(P1[i]/2);
			}while(++i<=N2);

			i=1;
			do{	U2[i]=(TP/beta_c)*(((I+Amp*sin(Omega*(t*TP+(TP/2)+ICounter*tN*TP)))/2)+Irand1[i]-dps[i]-
				(epsilon*sin(ps[i]+(Ps1[i]/2))+(1-epsilon)*sin((ps[i]+(Ps1[i]/2))/2))
				+(1./(2*beta_L))*(2*pi*(n-(phe/nu_l))-((sumps-sumph)/nu_j)));
			}while(++i<=N1);
			i=1;
			do{	V2[i]=(TP/beta_c)*(((I+Amp*sin(Omega*(t*TP+(TP/2)+ICounter*tN*TP)))/2)+Irand2[i]-dph[i]-
				(epsilon*sin(ph[i]+(P1[i]/2))+(1-epsilon)*sin((ph[i]+(P1[i]/2))/2))
				-(1./(2*beta_L))*(2*pi*(n-(phe/nu_l))-((sumps-sumph)/nu_j)));
			}while(++i<=N2);

			//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
			//The third coefficients of Runge-Kutta method
			//Третые коэффициенты метода Рунге-Кутта
			if(N1==1){
				dps[N1]=U[N1]+(U2[N1]/2);
				Ps3[N1]=TP*dps[N1];
			}else{
				if(c=='n'){
					i=1;
					dps[i]=(U[i]+(U2[i]/2))-alpha*(U[i+1]+(U2[i+1]/2)-(1+gamma)*(U[i]+(U2[i]/2)));
					Ps3[i]=TP*dps[i];

					i=N1;
					dps[i]=(U[i]+(U2[i]/2))-alpha*(U[i-1]+(U2[i-1]/2)-(1+gamma)*(U[i]+(U2[i]/2)));
					Ps3[i]=TP*dps[i];
					i=2; M1=N1;
				}

				if(c=='p'){i=1; U[0]=U[N1]; U2[0]=U2[N1]; U[N1+1]=U[1]; U2[N1+1]=U2[1]; M1=N1+1;}
				do{	dps[i]=U[i]+(U2[i]/2)-alpha*(U[i+1]+(U2[i+1]/2)+(U[i-1]+(U2[i-1]/2))-2*(U[i]+(U2[i]/2)));
					Ps3[i]=TP*dps[i];
				}while(++i<M1);
			}

			if(N2==1){
				dph[N2]=V[N2]+(V2[N2]/2);
				P3[N2]=TP*dph[N2];
			}else{
				if(c=='n'){
					i=1;
					dph[i]=(V[i]+(V2[i]/2))-alpha*(V[i+1]+(V2[i+1]/2)-(1+gamma)*(V[i]+(V2[i]/2)));
					P3[i]=TP*dph[i];

					i=N2;
					dph[i]=(V[i]+(V2[i]/2))-alpha*(V[i-1]+(V2[i-1]/2)-(1+gamma)*(V[i]+(V2[i]/2)));
					P3[i]=TP*dph[i];
					i=2; M2=N2;
				}

				if(c=='p'){i=1; V[0]=V[N2]; V2[0]=V2[N2]; V[N2+1]=V[1]; V2[N2+1]=V2[1]; M2=N2+1;}
				do{	dph[i]=V[i]+(V2[i]/2)-alpha*(V[i+1]+(V2[i+1]/2)+V[i-1]+(V2[i-1]/2)-2*(V[i]+(V2[i]/2)));
					P3[i]=TP*dph[i];
				}while(++i<M2);
			}

			sumps=0; i=1;
			do{sumps=sumps+ps[i]+(Ps2[i]/2);
			}while(++i<=N1);

			sumph=0; i=1;
			do{sumph=sumph+ph[i]+(P2[i]/2);
			}while(++i<=N2);

			i=1;
			do{	U3[i]=(TP/beta_c)*(((I+Amp*sin(Omega*(t*TP+(TP/2)+ICounter*tN*TP)))/2)+Irand1[i]-dps[i]-
				(epsilon*sin(ps[i]+(Ps2[i]/2))+(1-epsilon)*sin((ps[i]+(Ps2[i]/2))/2))
				+(1./(2*beta_L))*(2*pi*(n-(phe/nu_l))-((sumps-sumph)/nu_j)));
			}while(++i<=N1);

			i=1;
			do{	V3[i]=(TP/beta_c)*(((I+Amp*sin(Omega*(t*TP+(TP/2)+ICounter*tN*TP)))/2)+Irand2[i]-dph[i]-
				(epsilon*sin(ph[i]+(P2[i]/2))+(1-epsilon)*sin((ph[i]+(P2[i]/2))/2))
				-(1./(2*beta_L))*(2*pi*(n-(phe/nu_l))-((sumps-sumph)/nu_j)));
			}while(++i<=N2);
			//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
			//The fourth coefficients of Runge-Kutta method
			//Четвертые коэффициенты метода Рунге-Кутта
			if(N1==1){
				dps[N1]=U[N1]+U3[N1];
				Ps4[N1]=TP*dps[N1];
			}else{
				if(c=='n'){
					i=1;
					dps[i]=(U[i]+U3[i])-alpha*(U[i+1]+U3[i+1]-(1+gamma)*(U[i]+U3[i]));
					Ps4[i]=TP*dps[i];

					i=N1;
					dps[i]=(U[i]+U3[i])-alpha*(U[i-1]+U3[i-1]-(1+gamma)*(U[i]+U3[i]));
					Ps4[i]=TP*dps[i];
					i=2; M1=N1;
				}

				if(c=='p'){i=1; U[0]=U[N1]; U3[0]=U3[N1]; U[N1+1]=U[1]; U3[N1+1]=U3[1]; M1=N1+1;}
				do{	dps[i]=U[i]+U3[i]-alpha*(U[i+1]+U3[i+1]+(U[i-1]+U3[i-1])-2*(U[i]+U3[i]));
					Ps4[i]=TP*dps[i];
				}while(++i<M1);
			}

			if(N2==1){
				dph[N2]=V[N2]+V3[N2];
				P4[N2]=TP*dph[N2];
			}else{
				if(c=='n'){
					i=1;
					dph[i]=(V[i]+V3[i])-alpha*(V[i+1]+V3[i+1]-(1+gamma)*(V[i]+V3[i]));
					P4[i]=TP*dph[i];

					i=N2;
					dph[i]=V[i]+V3[i]-alpha*(V[i-1]+V3[i-1]-(1+gamma)*(V[i]+V3[i]));
					P4[i]=TP*dph[i];
					i=2; M2=N2;
				}

				if(c=='p'){i=1; V[0]=V[N2]; V3[0]=V3[N2]; V[N2+1]=V[1]; V3[N2+1]=V3[1]; M2=N2+1;}
				do{	dph[i]=V[i]+V3[i]-alpha*(V[i+1]+V3[i+1]+V[i-1]+V3[i-1]-2*(V[i]+V3[i]));
					P4[i]=TP*dph[i];
				}while(++i<M2);
			}

			sumps=0; i=1;
			do{sumps=sumps+ps[i]+Ps3[i];
			}while(++i<=N1);

			sumph=0; i=1;
			do{sumph=sumph+ph[i]+P3[i];
			}while(++i<=N2);

			i=1;
			do{	U4[i]=(TP/beta_c)*(((I+Amp*sin(Omega*(t*TP+TP+ICounter*tN*TP)))/2)+Irand1[i]-dps[i]-
				(epsilon*sin(ps[i]+Ps3[i])+(1-epsilon)*sin((ps[i]+Ps3[i])/2))
				+(1./(2*beta_L))*(2*pi*(n-(phe/nu_l))-((sumps-sumph)/nu_j)));
			}while(++i<=N1);


			i=1;
			do{	V4[i]=(TP/beta_c)*(((I+Amp*sin(Omega*(t*TP+TP+ICounter*tN*TP)))/2)+Irand2[i]-dph[i]-
				(epsilon*sin(ph[i]+P3[i])+(1-epsilon)*sin((ph[i]+P3[i])/2))
				-(1./(2*beta_L))*(2*pi*(n-(phe/nu_l))-((sumps-sumph)/nu_j)));
			}while(++i<=N2);
			//$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
			i=1;
			do{	ps[i]=ps[i]+(Ps1[i]+2*Ps2[i]+2*Ps3[i]+Ps4[i])/6;
				U[i]=U[i]+(U1[i]+2*U2[i]+2*U3[i]+U4[i])/6;
				if(t>ti) {intU[i]=intU[i]+U[i]*TP;}
			}while(++i<=N1);

			i=1;
			do{	ph[i]=ph[i]+(P1[i]+2*P2[i]+2*P3[i]+P4[i])/6;
				V[i]=V[i]+(V1[i]+2*V2[i]+2*V3[i]+V4[i])/6;
				if(t>ti) {intV[i]=intV[i]+V[i]*TP;}
			}while(++i<=N2);
		//Ending of Runge-Kutta method
		//Конец метода Рунге-Кутта
		//$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
			if(N1==1){
				dps[N1]=U[N1];
			}else{
				if(c=='n'){
					i=1;
					dps[i]=U[i]-alpha*(U[i+1]-(1+gamma)*U[i]);
					if(t>ti){intdps[i]=intdps[i]+dps[i]*TP;}

					i=N1;
					dps[i]=U[i]-alpha*(U[i-1]-(1+gamma)*U[i]);
					if(t>ti){intdps[i]=intdps[i]+dps[i]*TP;}
					i=2; M1=N1;
				}

				if(c=='p'){i=1; U[0]=U[N1]; U[N1+1]=U[1]; M1=N1+1;}
				do{	dps[i]=U[i]-alpha*(U[i+1]+U[i-1]-2*U[i]);
					if(t>ti){intdps[i]=intdps[i]+dps[i]*TP;}
				}while(++i<M1);
			}

			if(N2==1){
				dph[N2]=V[N2];
			}else{
				if(c=='n'){
					i=1;
					dph[i]=V[i]-alpha*(V[i+1]-(1+gamma)*V[i]);
					if(t>ti){intdph[i]=intdph[i]+dph[i]*TP;}
					i=N2;
					dph[i]=V[i]-alpha*(V[i-1]-(1+gamma)*V[i]);
					if(t>ti){intdph[i]=intdph[i]+dph[i]*TP;}
					i=2; M2=N2;
				}

				if(c=='p'){i=1; V[0]=V[N2]; V[N2+1]=V[1]; M2=N2+1;}
				do{	dph[i]=V[i]
					-alpha*(V[i+1]+V[i-1]-2*V[i]);
					if(t>ti){intdph[i]=intdph[i]+dph[i]*TP;}
				}while(++i<M2);
			}
//Начало вычисление отдельных токов
			i=1;
			do{	Is1[i]=epsilon*sin(ps[i])+(1-epsilon)*sin(ps[i]/2);
				Idisp1[i]=beta_c*(U[i]-U0[i])/TP;
				Iqp1[i]=U[i];
				Idif1[i]=(dps[i]-U[i]);

				Isum1[i]=Is1[i]+Idisp1[i]+Iqp1[i]+Idif1[i];

				if(t>ti){
					intIs1[i]=intIs1[i]+Is1[i]*TP;
					intIdisp1[i]=intIdisp1[i]+Idisp1[i]*TP;
					intIqp1[i]=intIqp1[i]+Iqp1[i]*TP;
					intIdif1[i]=intIdif1[i]+Idif1[i]*TP;

					intIsum1[i]=intIsum1[i]+Isum1[i]*TP;
				}
			}while(++i<=N1);

			i=1;
			do{	Is2[i]=epsilon*sin(ph[i])+(1-epsilon)*sin(ph[i]/2);
				Idisp2[i]=beta_c*(V[i]-V0[i])/TP;
				Iqp2[i]=V[i];
				Idif2[i]=(dph[i]-V[i]);

				Isum2[i]=Is2[i]+Idisp2[i]+Iqp2[i]+Idif2[i];

				if(t>ti){
					intIs2[i]=intIs2[i]+Is2[i]*TP;
					intIdisp2[i]=intIdisp2[i]+Idisp2[i]*TP;
					intIqp2[i]=intIqp2[i]+Iqp2[i]*TP;
					intIdif2[i]=intIdif2[i]+Idif2[i]*TP;

					intIsum2[i]=intIsum2[i]+Isum2[i]*TP;
				}
			}while(++i<=N2);
			//Конец вычисление отдельных токов

			//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
			// Starting of time dependence calculation
			// Начало вычисления временных зависимостей
			if((time_dep==1)&&(I<(Itime2+JP1/2))&&(I>(Itime1-JP1/2))&&(a==at))
				{pt=1;tN=Tf1/TP;Tf=Tf1;
				//Recording time Formula
				//Формула записываемого времени
				if(at==-1){time=t*TP-(TP*tN*(Itime2-I)*at)/JP;}
				if(at==1){time=t*TP+(TP*tN*(I-Itime1)*at)/JP;}
				//**************************************
				//Time recording
				//Запись времени
				fprintf(fchtime1,"%f\t",time);
				fprintf(fchtime2,"%f\t",time);

				fprintf(fvtime1,"%f\t",time);
				fprintf(fvtime2,"%f\t",time);

				fprintf(fIs1time,"%f\t",time);		fprintf(fIs2time,"%f\t",time);
				fprintf(fIqp1time,"%f\t",time);		fprintf(fIqp2time,"%f\t",time);
				fprintf(fIdisp1time,"%f\t",time);	fprintf(fIdisp2time,"%f\t",time);
				fprintf(fIdif1time,"%f\t",time);	fprintf(fIdif2time,"%f\t",time);

				i=1;
				do{	fprintf(fIs1time,"%e\t",Is1[i]);
					fprintf(fIqp1time,"%e\t",Iqp1[i]);
					fprintf(fIdisp1time,"%e\t",Idisp1[i]);
					fprintf(fIdif1time,"%e\t",Idif1[i]);
				}while(++i<=N1);

				i=1;
				do{	fprintf(fIs2time,"%e\t",Is2[i]);
					fprintf(fIqp2time,"%e\t",Iqp2[i]);
					fprintf(fIdisp2time,"%e\t",Idisp2[i]);
					fprintf(fIdif2time,"%e\t",Idif2[i]);
				}while(++i<=N2);

				//*************************************************
				//Calculation of charge value for middle layers
				//Вычисление значения заряда в промежуточных слоях
				i=1;
				do{	Ch1[i]=alpha*(U[i+1]-U[i]);
				}while(++i<=N1-1);

				i=1;
				do{	Ch2[i]=alpha*(V[i+1]-V[i]);
				}while(++i<=N2-1);
				//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
				//Calculation of charge value for last layer at periodic boundary condition (BC)
				//at periodic BC, charge value for first and last layers are identical
				//Вычисление значения заряда на последном слое при периодических граничных условий (ГУ)
				//при периодическом ГУ значения заряда на первом и последном слоях идентичны
				if(c=='p'){Ch1[N1]=alpha*(U[1]-U[N1]);}

				if(c=='p'){Ch2[N2]=alpha*(V[1]-V[N2]);}
				//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
				if(c=='n'){
					//Calculation of charge value for first layer at nonperiodic BC
					//вычисления значения заряда на первом слое при не периодических ГУ
					Ch1[0]=alpha*(U[1]);
					Ch2[0]=alpha*(V[1]);
					//Calculation of charge value for last layer at nonperiodic BC
					//вычисления значения заряда на последном слое при не периодических ГУ
					Ch1[N1]=-alpha*(U[N1]);
					Ch2[N2]=-alpha*(V[N2]);
					//Here will be recorded charge in first layer at nonperiodic BC
					//Здесь записывается заряд на первом слое при не периодических ГУ
					fprintf(fchtime1,"%e\t",Ch1[0]);
					fprintf(fchtime2,"%e\t",Ch2[0]);
				}
				//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
				i=1;
				do{	//Here will be recorded charge in all layers
					//Здесь записывается заряд на всех слоях
					fprintf(fchtime1,"%e\t",Ch1[i]);
					//Here will be recorded voltage in all junctions
					//Здесь записывается напряжение на всех контактах
					fprintf(fvtime1,"%e\t",U[i]);
				}while(++i<=N1);

				i=1;
				do{	//Here will be recorded charge in all layers
					//Здесь записывается заряд на всех слоях
					fprintf(fchtime2,"%e\t",Ch2[i]);
					//Here will be recorded voltage in all junctions
					//Здесь записывается напряжение на всех контактах
					fprintf(fvtime2,"%e\t",V[i]);
				}while(++i<=N2);
				//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
				//Here will be recorded bias current
				//Здесь записывается входной ток
				fprintf(fchtime1,"%f\t%e\t",I,Isum1av[N1]);
				fprintf(fchtime2,"%f\t%e\t",I,Isum2av[N2]);
				fprintf(fvtime1,"%f\t%e\t",I,Isum1av[N1]);
				fprintf(fvtime2,"%f\t%e\t",I,Isum2av[N2]);

				fprintf(fIs1time,"%f\t%e\t",I,Isum1av[N1]);
				fprintf(fIqp1time,"%f\t%e\t",I,Isum1av[N1]);
				fprintf(fIdisp1time,"%f\t%e\t",I,Isum1av[N1]);
				fprintf(fIdif1time,"%f\t%e\t",I,Isum1av[N1]);

				fprintf(fIs2time,"%f\t%e\t",I,Isum2av[N2]);
				fprintf(fIqp2time,"%f\t%e\t",I,Isum2av[N2]);
				fprintf(fIdisp2time,"%f\t%e\t",I,Isum2av[N2]);
				fprintf(fIdif2time,"%f\t%e\t",I,Isum2av[N2]);

				//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
				//Going to new line
				//Переход на новую строку
				fprintf(fchtime1,"\n");
				fprintf(fchtime2,"\n");
				fprintf(fvtime1,"\n");
				fprintf(fvtime2,"\n");

				fprintf(fIs1time,"\n");
				fprintf(fIqp1time,"\n");
				fprintf(fIdisp1time,"\n");
				fprintf(fIdif1time,"\n");

				fprintf(fIs2time,"\n");
				fprintf(fIqp2time,"\n");
				fprintf(fIdisp2time,"\n");
				fprintf(fIdif2time,"\n");

			}else{tN=Tf0/TP;Tf=Tf0;};
		// Ending of time dependence calculation
		//Конец вычисления временных зависимостей
		//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
		}while(++t<tN+1);
		//Конец цикла по времени
		//Начало усреднение по времени $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

		i=1; u=0;
		do{	Uav[i]=intU[i]/(Tf-Ti);
			intU[i]=0;
			dpsav[i]=intdps[i]/(Tf-Ti);
			intdps[i]=0;
			u=u+Uav[i];
		}while(++i<=N1);

		i=1; v=0;
		do{	Vav[i]=intV[i]/(Tf-Ti);
			intV[i]=0;
			dphav[i]=intdph[i]/(Tf-Ti);
			intdph[i]=0;
			v=v+Vav[i];
		}while(++i<=N2);

		i=1;
		do{	Is1av[i]=intIs1[i]/(Tf-Ti);
			intIs1[i]=0;
			Idisp1av[i]=intIdisp1[i]/(Tf-Ti);
			intIdisp1[i]=0;
			Iqp1av[i]=intIqp1[i]/(Tf-Ti);
			intIqp1[i]=0;
			Idif1av[i]=intIdif1[i]/(Tf-Ti);
			intIdif1[i]=0;
		}while(++i<=N1);

		i=1;
		do{
			Isum1av[i]=intIsum1[i]/(Tf-Ti);
			intIsum1[i]=0;
		}while(++i<=N1);

		i=1;
		do{	Is2av[i]=intIs2[i]/(Tf-Ti);
			intIs2[i]=0;
			Idisp2av[i]=intIdisp2[i]/(Tf-Ti);
			intIdisp2[i]=0;
			Iqp2av[i]=intIqp2[i]/(Tf-Ti);
			intIqp2[i]=0;
			Idif2av[i]=intIdif2[i]/(Tf-Ti);
			intIdif2[i]=0;
		}while(++i<=N2);

		i=1;
		do{
			Isum2av[i]=intIsum2[i]/(Tf-Ti);
			intIsum2[i]=0;
		}while(++i<=N2);
		//Конец усреднение по времени
		fprintf(totalI,"%f\t",I);

		i=1;
		do{	Isum[i]=Isum1av[i]+Isum2av[N2];
			fprintf(totalI,"%e\t",Isum[i]);
		}while(++i<=N1);

		i=1;
		do{	Isum[N1+i]=Isum1av[N1]+Isum2av[i];
			fprintf(totalI,"%e\t",Isum[N1+i]);
		}while(++i<=N2);
		fprintf(totalI,"\n");
		//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		//showing results on the screen
		//вывод результатов на экран
		cout<<"\n\nI:"<<I<<"\tV:"<<v;
		//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		//Запис ВАХ
		fprintf(cvctotal,"%f\t%e\n",I,v);


		fprintf(cvctotalj1,"%f\t%e\t",I,u);
		fprintf(cvcstack1,"%e\t%e\t",Isum1av[N1],u);
		i=1;
		do{	fprintf(cvctotalj1,"%e\t",Uav[i]);
			fprintf(cvcstack1,"%e\t",Uav[i]);
		}while(++i<=N1);
		fprintf(cvctotalj1,"\n");
		fprintf(cvcstack1,"\n");


		fprintf(cvctotalj2,"%f\t%e\t",I,v);
		fprintf(cvcstack2,"%e\t%e\t",Isum2av[N2],v);
		i=1;
		do{	fprintf(cvctotalj2,"%e\t",Vav[i]);
			fprintf(cvcstack2,"%e\t",Vav[i]);
		}while(++i<=N2);
		fprintf(cvctotalj2,"\n");
		fprintf(cvcstack2,"\n");


		if(a==1){
			//Запись ВАХ
			fprintf(cvctotalup,"%f\t%e\n",I,v);

			fprintf(cvctotalj1up,"%f\t%e\t",I,u);
			fprintf(cvcstack1up,"%e\t%e\t",Isum1av[N1],u);
			//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
			fprintf(fdpstotalup,"%f\t",I);
			fprintf(fdpsstackup,"%f\t",Isum1av[N1]);
			//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
			fprintf(fIs1up,"%f\t",I);
			fprintf(fIs1stack1up,"%e\t",Isum1av[N1]);
			fprintf(fIqp1up,"%f\t",I);
			fprintf(fIqp1stack1up,"%e\t",Isum1av[N1]);
			fprintf(fIdisp1up,"%f\t",I);
			fprintf(fIdisp1stack1up,"%e\t",Isum1av[N1]);
			fprintf(fIdif1up,"%f\t",I);
			fprintf(fIdif1stack1up,"%e\t",Isum1av[N1]);
			//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
			i=1;
			do{	fprintf(cvctotalj1up,"%e\t",Uav[i]);
				fprintf(cvcstack1up,"%e\t",Uav[i]);
				//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
				fprintf(fdpstotalup,"%e\t",dpsav[i]);
				fprintf(fdpsstackup,"%e\t",dpsav[i]);
				//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
				fprintf(fIs1up,"%e\t",Is1av[i]);
				fprintf(fIs1stack1up,"%e\t",Is1av[i]);
				fprintf(fIqp1up,"%e\t",Iqp1av[i]);
				fprintf(fIqp1stack1up,"%e\t",Iqp1av[i]);
				fprintf(fIdisp1up,"%e\t",Idisp1av[i]);
				fprintf(fIdisp1stack1up,"%e\t",Idisp1av[i]);
				fprintf(fIdif1up,"%e\t",Idif1av[i]);
				fprintf(fIdif1stack1up,"%e\t",Idif1av[i]);

			}while(++i<=N1);

			fprintf(cvctotalj1up,"\n");
			fprintf(cvcstack1up,"\n");
			//~~~~~~~~~~~~~~~~~~~~~~~~~~~
			fprintf(fdpstotalup,"\n");
			fprintf(fdpsstackup,"\n");
			//~~~~~~~~~~~~~~~~~~~~~~~~~~~
			fprintf(fIs1up,"\n");
			fprintf(fIs1stack1up,"\n");
			fprintf(fIqp1up,"\n");
			fprintf(fIqp1stack1up,"\n");
			fprintf(fIdisp1up,"\n");
			fprintf(fIdisp1stack1up,"\n");
			fprintf(fIdif1up,"\n");
			fprintf(fIdif1stack1up,"\n");
			//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

			fprintf(cvctotalj2up,"%f\t%e\t",I,v);
			fprintf(cvcstack2up,"%e\t%e\t",Isum2av[N2],v);


			fprintf(fdphtotalup,"%f\t",I);
			fprintf(fdphstackup,"%f\t",Isum2av[N2]);

			fprintf(fIs2up,"%f\t",I);
			fprintf(fIs2stack2up,"%e\t",Isum2av[N2]);
			fprintf(fIqp2up,"%f\t",I);
			fprintf(fIqp2stack2up,"%e\t",Isum2av[N2]);
			fprintf(fIdisp2up,"%f\t",I);
			fprintf(fIdisp2stack2up,"%e\t",Isum2av[N2]);
			fprintf(fIdif2up,"%f\t",I);
			fprintf(fIdif2stack2up,"%e\t",Isum2av[N2]);

			i=1;
			do{	fprintf(cvctotalj2up,"%e\t",Vav[i]);
				fprintf(cvcstack2up,"%e\t",Vav[i]);

				fprintf(fdphtotalup,"%e\t",dphav[i]);
				fprintf(fdphstackup,"%e\t",dphav[i]);

				fprintf(fIs2up,"%e\t",Is2av[i]);
				fprintf(fIs2stack2up,"%e\t",Is2av[i]);
				fprintf(fIqp2up,"%e\t",Iqp2av[i]);
				fprintf(fIqp2stack2up,"%e\t",Iqp2av[i]);
				fprintf(fIdisp2up,"%e\t",Idisp2av[i]);
				fprintf(fIdisp2stack2up,"%e\t",Idisp2av[i]);
				fprintf(fIdif2up,"%e\t",Idif2av[i]);
				fprintf(fIdif2stack2up,"%e\t",Idif2av[i]);

			}while(++i<=N2);

			fprintf(cvctotalj2up,"\n");
			fprintf(cvcstack2up,"\n");

			fprintf(fdphtotalup,"\n");
			fprintf(fdphstackup,"\n");

			fprintf(fIs2up,"\n");
			fprintf(fIs2stack2up,"\n");
			fprintf(fIqp2up,"\n");
			fprintf(fIqp2stack2up,"\n");
			fprintf(fIdisp2up,"\n");
			fprintf(fIdisp2stack2up,"\n");
			fprintf(fIdif2up,"\n");
			fprintf(fIdif2stack2up,"\n");
			//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		}


		if(a==-1){
			fprintf(cvctotaldown,"%f\t%e\n",I,v);

			fprintf(cvcstack1down,"%e\t%e\t",Isum1av[N1],u);
			fprintf(cvctotalj1down,"%f\t%e\t",I,u);
			//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
			fprintf(fdpstotaldown,"%f\t",I);
			fprintf(fdpsstackdown,"%f\t",Isum1av[N1]);

			fprintf(fIs1down,"%f\t",I);
			fprintf(fIs1stack1down,"%e\t",Isum1av[N1]);
			fprintf(fIqp1down,"%f\t",I);
			fprintf(fIqp1stack1down,"%e\t",Isum1av[N1]);
			fprintf(fIdisp1down,"%f\t",I);
			fprintf(fIdisp1stack1down,"%e\t",Isum1av[N1]);
			fprintf(fIdif1down,"%f\t",I);
			fprintf(fIdif1stack1down,"%e\t",Isum1av[N1]);

			i=1;
			do{	fprintf(cvctotalj1down,"%e\t",Uav[i]);
				fprintf(cvcstack1down,"%e\t",Uav[i]);

				fprintf(fdpstotaldown,"%e\t",dpsav[i]);
				fprintf(fdpsstackdown,"%e\t",dpsav[i]);

				fprintf(fIs1down,"%e\t",Is1av[i]);
				fprintf(fIs1stack1down,"%e\t",Is1av[i]);
				fprintf(fIqp1down,"%e\t",Iqp1av[i]);
				fprintf(fIqp1stack1down,"%e\t",Iqp1av[i]);
				fprintf(fIdisp1down,"%e\t",Idisp1av[i]);
				fprintf(fIdisp1stack1down,"%e\t",Idisp1av[i]);
				fprintf(fIdif1down,"%e\t",Idif1av[i]);
				fprintf(fIdif1stack1down,"%e\t",Idif1av[i]);

			}while(++i<=N1);

			fprintf(cvctotalj1down,"\n");
			fprintf(cvcstack1down,"\n");

			fprintf(fdpstotaldown,"\n");
			fprintf(fdpsstackdown,"\n");

			fprintf(fIs1down,"\n");
			fprintf(fIs1stack1down,"\n");
			fprintf(fIqp1down,"\n");
			fprintf(fIqp1stack1down,"\n");
			fprintf(fIdisp1down,"\n");
			fprintf(fIdisp1stack1down,"\n");
			fprintf(fIdif1down,"\n");
			fprintf(fIdif1stack1down,"\n");
			//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
			fprintf(cvcstack2down,"%e\t%e\t",Isum2av[N2],v);
			fprintf(cvctotalj2down,"%f\t%e\t",I,v);

			fprintf(fdphtotaldown,"%f\t",I);
			fprintf(fdphstackdown,"%f\t",Isum2av[N2]);


			fprintf(fIs2down,"%f\t",I);
			fprintf(fIs2stack2down,"%e\t",Isum2av[N2]);
			fprintf(fIqp2down,"%f\t",I);
			fprintf(fIqp2stack2down,"%e\t",Isum2av[N2]);
			fprintf(fIdisp2down,"%f\t",I);
			fprintf(fIdisp2stack2down,"%e\t",Isum2av[N2]);
			fprintf(fIdif2down,"%f\t",I);
			fprintf(fIdif2stack2down,"%e\t",Isum2av[N2]);

			i=1;
			do{	fprintf(cvctotalj2down,"%e\t",Vav[i]);
				fprintf(cvcstack2down,"%e\t",Vav[i]);

				fprintf(fdphtotaldown,"%e\t",dphav[i]);
				fprintf(fdphstackdown,"%e\t",dphav[i]);

				fprintf(fIs2down,"%e\t",Is2av[i]);
				fprintf(fIs2stack2down,"%e\t",Is2av[i]);
				fprintf(fIqp2down,"%e\t",Iqp2av[i]);
				fprintf(fIqp2stack2down,"%e\t",Iqp2av[i]);
				fprintf(fIdisp2down,"%e\t",Idisp2av[i]);
				fprintf(fIdisp2stack2down,"%e\t",Idisp2av[i]);
				fprintf(fIdif2down,"%e\t",Idif2av[i]);
				fprintf(fIdif2stack2down,"%e\t",Idif2av[i]);

			}while(++i<=N2);

			fprintf(cvctotalj2down,"\n");
			fprintf(cvcstack2down,"\n");

			fprintf(fdphtotaldown,"\n");
			fprintf(fdphstackdown,"\n");

			fprintf(fIs2down,"\n");
			fprintf(fIs2stack2down,"\n");
			fprintf(fIqp2down,"\n");
			fprintf(fIqp2stack2down,"\n");
			fprintf(fIdisp2down,"\n");
			fprintf(fIdisp2stack2down,"\n");
			fprintf(fIdif2down,"\n");
			fprintf(fIdif2stack2down,"\n");

		}

		//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		//Condition for breaking
		//Условие для приостановления
		if (I<0)break;

		if (I>Imax)
		{	cout<<"\n\n Here is max of current so we go back"<<endl;
			a=-1;
		}

		ICounter=ICounter+1;
		//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		I=I+a*JP;
		if ((I<=Imore2+JP1/2)&&(I>=Imore1-JP1/2)&&(a==-1)){JP=JP1;}else{JP=JP0;};
	}while(I<=100);

	fclose(cvctotal);	fclose(cvctotalup);		fclose(cvctotaldown);
	fclose(cvctotalj1);	fclose(cvctotalj1up);	fclose(cvctotalj1down);
	fclose(cvctotalj2);	fclose(cvctotalj2up);	fclose(cvctotalj2down);

	fclose(cvcstack1);	fclose(cvcstack1up);	fclose(cvcstack1down);
	fclose(cvcstack2);	fclose(cvcstack2up);	fclose(cvcstack2down);

	fclose(fdpstotalup);	fclose(fdpsstackup);
	fclose(fdphtotalup);	fclose(fdphstackup);

	fclose(fdpstotaldown);	fclose(fdpsstackdown);
	fclose(fdphtotaldown);	fclose(fdphstackdown);

	fclose(fIs1up);			fclose(fIs1down);
	fclose(fIs1stack1up);	fclose(fIs1stack1down);

	fclose(fIqp1up);		fclose(fIqp1down);
	fclose(fIqp1stack1up);	fclose(fIqp1stack1down);

	fclose(fIdisp1up);		fclose(fIdisp1down);
	fclose(fIdisp1stack1up);fclose(fIdisp1stack1down);

	fclose(fIdif1up);		fclose(fIdif1down);
	fclose(fIdif1stack1up);	fclose(fIdif1stack1down);

	fclose(fIs2up);			fclose(fIs2down);
	fclose(fIs2stack2up);	fclose(fIs2stack2down);

	fclose(fIqp2up);		fclose(fIqp2down);
	fclose(fIqp2stack2up);	fclose(fIqp2stack2down);

	fclose(fIdisp2up);		fclose(fIdisp2down);
	fclose(fIdisp2stack2up);fclose(fIdisp2stack2down);
	fclose(fIdif2up);		fclose(fIdif2down);
	fclose(fIdif2stack2up);	fclose(fIdif2stack2down);

	//fclose(fchtime1);	fclose(fchtime2);
	//fclose(fvtime1);	fclose(fvtime2);


	//fclose(fIs1time);
	//fclose(fIqp1time);
	//fclose(fIdisp1time);
	//fclose(fIdif1time);

	//fclose(fIs2time);
	//fclose(fIqp2time);
	//fclose(fIdisp2time);
	//fclose(fIdif2time);


	fclose(totalI);
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	return(0);
}
